untyped
global function rangefinderPrecache

struct{
    bool usesMetric = true //true: uses meters; false: uses feet
    bool addHammer = false //true: adds a range display in hammer units under the previous one; false: no effect
    vector position = Vector(0.3, 0.25, 0.0) //x axis: 0.0 is max left, 1.0 is max right; y axis: 0.0 is max top, 1.0 is max down; z doesn't do anything
    vector colour = Vector(1.0, 0.55, 0.0) //standard rgb format, range: min - 0.0 to max - 1.0
    float alpha = 0.9 //maxiumum alpha of the text, range: 0.0 to 1.0
    float size = 42.0 //size of the text
} settings

void function rangefinderPrecache(){
    thread rangeFinderInit()
}

var distDisplay = null
const int dist = 55555

void function rangeFinderInit(){
    WaitFrame()
    distDisplay = RuiCreate( $"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1 )
	RuiSetInt(distDisplay, "maxLines", 1)
	RuiSetInt(distDisplay, "lineNum", 1)
	RuiSetFloat2(distDisplay, "msgPos", settings.position)
	RuiSetString(distDisplay, "msgText", "ERROR :(")
	RuiSetFloat(distDisplay, "msgFontSize", settings.size)
	RuiSetFloat(distDisplay, "msgAlpha", 0.0)
	RuiSetFloat(distDisplay, "thicken", 0.0)
	RuiSetFloat3(distDisplay, "msgColor", settings.colour)
    thread rangeFinderMain()
}

void function rangeFinderMain(){
    while(true)
    {
        WaitFrame()
        entity player = GetLocalViewPlayer()
        if (player == null || !IsValid(player))
			continue
        if(!IsLobby() && !IsMenuLevel() && player == GetLocalClientPlayer()){
            vector forward = AnglesToForward(player.EyeAngles())
	        TraceResults trace = TraceLine(player.EyePosition(), player.EyePosition() + (dist * forward), null, TRACE_MASK_NPCSOLID ) 
	        float hDist = Distance(player.EyePosition(), trace.endPos )
            float dDist = hDist * 0.01904 * (4/3)
            if(!settings.usesMetric)
                dDist *= 3.28084
            string dDistStr = " " + " " + format("%3i", dDist)
            if(settings.usesMetric)
                dDistStr += "M"
            else
                dDistStr += "FT"
            if(settings.addHammer)
                dDistStr += ("\n" + format("%4i", hDist) + "HU")
            if(hDist < 526)
                RuiSetFloat(distDisplay, "msgAlpha", (settings.alpha)/2)
            else
                RuiSetFloat(distDisplay, "msgAlpha", settings.alpha)
            RuiSetString(distDisplay, "msgText", dDistStr)
        }
        else
            RuiSetFloat(distDisplay, "msgAlpha", 0.0)
    }
}